class OrderSetItemPdf < Prawn::Document
  include ActionView::Helpers::NumberHelper
  attr_accessor :label_width,:price_column_width,:page_width, :page_height, :margin, :price_width, :item_width, :header_font_size, :item_font_size,:item_height,:qty_width,:total_width,:item_description_width
  def initialize(print_settings,order_set_item, print_status, options, alt_name, before_updated_qty)
    self.page_width = print_settings.page_width
    self.page_height = print_settings.page_height
    self.header_font_size = print_settings.header_font_size.to_i
    self.item_font_size = print_settings.item_font_size.to_i
    self.margin = 0
    self.price_width = 40 # No Need for item
    self.qty_width = 40
    self.total_width = 40  # No Need for item
    self.item_width = self.page_width - (self.qty_width - self.margin)
    self.item_height = 15   
    self.item_description_width = self.page_width - (self.price_width + self.qty_width + self.total_width)
    self.label_width=90   

    super(:margin => [print_settings.heading_space, self.margin, self.margin, self.margin], :page_size => [self.page_width, self.page_height])
    # super(:margin => [10, 5, 30, 5], :page_size => [200,400])

    # db font setup
    if print_settings.font != ""
        font_families.update("#{print_settings.font}" => {
            :normal => "public/fonts/#{print_settings.font}.ttf",
            :italic => "public/fonts/#{print_settings.font}.ttf",
            :bold => "public/fonts/#{print_settings.font}.ttf",
            :bold_italic => "public/fonts/#{print_settings.font}.ttf"
        })

        font "#{print_settings.font}"
        fallback_fonts ["Courier", "Helvetica", "Times-Roman"]     
    end
     # font "public/fonts/Zawgyi-One.ttf"
     # font "public/fonts/padauk.ttf"  
     #font "public/fonts/Chinese.ttf"     
    if !order_set_item.dining.nil?
      text "#{ order_set_item.type + '-' + order_set_item.dining + print_status }", :size => self.header_font_size,:align => :center, :left_margin => -20
    else
      text "#{ print_status }", :size => self.header_font_size,:align => :center, :left_margin => -20
    end
    stroke_horizontal_rule
    move_down 3

    #order_info
    order_info(order_set_item.order_id, order_set_item.order_by,order_set_item.order_at)

    # order items
    order_set_items(order_set_item, options, alt_name, print_settings.precision, before_updated_qty)
  end

  # Write Order Information to PDF
  def order_info(order_no, order_by, order_at)  
    #booking ID
    booking_id = get_booking_id(order_no)

    y_position = cursor
    bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
        text "Booking: #{booking_id}", :size => self.item_font_size,:align => :left    
    end

    move_down 2
    y_position = cursor
    bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
        text "OrderNo: #{order_no} ", :size => self.item_font_size,:align => :left    
    end

    move_down 2
    y_position = cursor
    bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
        text "OrderBy: #{order_by} ", :size => self.item_font_size,:align => :left    
    end

    move_down 2
    y_position = cursor
    bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
        text "Date: #{order_at.utc.getlocal.strftime("%Y-%m-%d %I:%M %p")}", :size => self.item_font_size,:align => :left    
    end

    stroke_horizontal_rule

    move_down 10
  end

  # Write Order items to PDF
  def order_set_items(order_set_item, options, alt_name, precision, before_updated_qty)
    y_position = cursor

    #Add Order Item    
    add_order_set_items(order_set_item, options, alt_name, precision)

    dash(1, :space => 1, :phase => 1)
    stroke_horizontal_line 0, (self.page_width - self.margin)
    add_updated_qty_text(before_updated_qty, order_set_item.qty, precision)
    move_down 5
  end

  # Add order items under order info
  def add_order_set_items(order_set_item, options, alt_name, precision)
    y_position = cursor

    move_down 5

    bounding_box([0,y_position], :width => self.item_width) do
        text "#{order_set_item.item_code} - #{order_set_item.item_name}", :size => self.item_font_size,:align => :left
    end

    bounding_box([self.item_width,y_position], :width => self.qty_width) do
        text "[#{number_with_precision(order_set_item.qty.to_i, :precision => precision.to_i)}]", :size => self.item_font_size,:align => :left
    end

    bounding_box([0,y_position], :width => self.item_width) do
      text "#{order_set_item.item_code} - #{order_set_item.item_name}", :size => self.item_font_size,:align => :left

    end

    if alt_name
        if order_set_item.alt_name
            move_down 4
            # font("public/fonts/NotoSansCJKtc-Regular.ttf") do
                text "(#{order_set_item.alt_name})", :size => self.item_font_size,:align => :left, :inline_format => true
            # end
        end
    end

    #add set menu items
    if !order_set_item.set_menu_items.nil?
      set_menu_items = JSON.parse(order_set_item.set_menu_items)
      if !set_menu_items.empty?
        # json_item_instance_code = nil
        set_menu_items.each do |set_item|
            # if set_item["item_instance_code"] != json_item_instance_code
                item_instance_name = MenuItemInstance.find_by_item_instance_code(set_item["item_instance_code"]).item_instance_name
                move_down 2
                text "#{item_instance_name}", :size => self.item_font_size,:align => :left, :inline_format => true
            # end
            # json_item_instance_code = set_item["item_instance_code"]
        end
      end
    end

    if !options.empty?
        move_down 5

        # add option
        y_position = cursor
        bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
            text "#{options}", :size => self.item_font_size,:align => :left
        end
    end

    move_down 5

  end

    #add updated qty text
    def add_updated_qty_text(before_updated_qty, updated_qty, precision)
        if before_updated_qty.to_i > 0 && !before_updated_qty.nil?
            move_down 5

            # add option
            y_position = cursor
            bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
                text "* Change quantity [#{number_with_precision(before_updated_qty.to_i, :precision => precision.to_i)}] to [#{number_with_precision(updated_qty.to_i, :precision => precision.to_i)}]", :size => self.item_font_size,:align => :left
            end
        end
    end

    def get_booking_id(order_no)
        booking = Booking.joins(" JOIN booking_orders bo ON bo.booking_id = bookings.booking_id")
                .joins(" JOIN orders o ON o.order_id=bo.order_id")
                .where("o.order_id='#{order_no}'")
                .first()

        return booking.booking_id
    end

end
